
;;(defparameter *filter-by-uncond* t)

(defun leq-compares-incr-lhs (rhs old-lhs new-lhs)
  (list.cartesian (create-range old-lhs (+ new-lhs 1)) (create-range 1 (+ rhs 1))))

(defun leq-compares-incr-rhs (lhs old-rhs new-rhs)
  (list.cartesian (create-range 1 (+ lhs 1)) (create-range old-rhs (+ new-rhs 1))))

;; does some simple symbolic arithmetic checks to see if an equivalent conjecture will have been found
(defun is-minimal-terms-for-leq (term term*)
  (or (not *do-invariant-pruning*)
      (if (and (term.is-fun term) (term.is-fun term*))
	  (if (or (and (equal (term.fun-sym term) 'c-int-+)
		       (equal (term.fun-sym term*) 'c-int-+))
		  (and (equal (term.fun-sym term) 'c-int--)
		       (equal (term.fun-sym term*) 'c-int--))
		  ;; this may be a bad thing to do some of the time but I think it is usually a good thing to do.
		  ;; For c-uint-* it is fine since Z is an integral domain and we have disjunction?
		  (and (equal (term.fun-sym term) 'c-int-*)
		       (equal (term.fun-sym term*) 'c-int-*)))
	      (if (or (term.equal (car (term.args term))
				  (car (term.args term*)))
		      (term.equal (cadr (term.args term))
				  (cadr (term.args term*))))
		  nil
	    t)
	    t)
	t)
      (not (and (equal (term.type term) 'c-uintp)
		(or (equal (term.destruct term) 0)
		    (equal (term.destruct term*) 0))))))
	   

(defun find-leq-invariants-single (term term* invariantds new-invs-list generalized-target target uncond-target keep <-or-<= S)
  (let* ((key (if (equal <-or-<= '<)
		  (<-key.make (term.size term) (term.size term*))
		(<=-key.make (term.size term) (term.size term*))))
	 (invariantd (if (equal <-or-<= '<) (<-invariantd.make term term* S) (<=-invariantd.make term term* S))))
    (populate-invariantd-data invariantd uncond-target)
    (if (or (list.forall #'(lambda (x) (and (option.exists x) (option.get x))) (invariantd.get-data invariantd uncond-target))
	    (list.forall #'(lambda (x) (and (option.exists x) (not (option.get x)))) (invariantd.get-data invariantd uncond-target)))
	(list invariantds new-invs-list)
      (let* ((_ (populate-invariantd-data invariantd target))
	     (_ (populate-invariantd-data invariantd generalized-target))
	     (changed nil)
	     (any-generalized (not (endp (invariantd.get-data invariantd generalized-target))))
	     (new-invs-list* (let* ((test-1 (list.forall #'(lambda (x) (and (option.exists x) (option.get x)))
							 (invariantd.get-data invariantd target)))
				    (test-2 (list.forall #'(lambda (x) (and (option.exists x) (option.get x)))
							 (invariantd.get-data invariantd generalized-target))))
			       (if (or test-1 (and any-generalized test-2))
				   (progn (if (and test-1 test-2)
					      (setf changed t) ;;TODO:DANGER
					    '_) 
					  (cons invariantd new-invs-list))
				 new-invs-list)))
	     (invariantds* (if (and keep (not changed))
			       (map.add-overwrite invariantds key (cons invariantd (map.find-exn invariantds key)))
			     invariantds)))
	(list invariantds* new-invs-list*)))))

(defparameter *leq-invariants/do-<* t)
(defun find-leq/lt-invariants-single (term term* invariantds new-invs-list generalized-target target uncond-target keep S)
  (if (and (not (term.equal term term*))
	   (not (and (is-term-ground term S) (is-term-ground term* S)))
	   (list.forall #'option.exists (term.get-evals term target))
	   (list.forall #'option.exists (term.get-evals term* target))
	   (term.is-minimal term uncond-target)
	   (term.is-minimal term* uncond-target)
	   (list-subset (list-intersect (term-variables term S)
					(term-variables term* S))
			*constant-vars*)
	   (is-minimal-terms-for-leq term term*))
      (let* ((res (if *leq-invariants/do-<*
		      (find-leq-invariants-single term term* invariantds new-invs-list generalized-target target uncond-target keep '< S)
		    (list invariantds new-invs-list)))
	     (invariantds* (car res))
	     (new-invs-list* (cadr res))
	     (res* (find-leq-invariants-single term term* invariantds* new-invs-list* generalized-target target uncond-target keep '<= S))
	     (invariantds** (car res*))
	     (new-invs-list** (cadr res*)))
	(list invariantds** new-invs-list**))
    (list invariantds new-invs-list)))

(defun find-leq-invariants-pair (terms terms* generalized-target target uncond-target invariantds new-invs-list keep S)
  (list.foldr #'(lambda (term acc)
		  (list.foldr #'(lambda (term* acc)
				  (let* ((invariantds (car acc))
					 (new-invs-list (cadr acc)))
				    (find-leq/lt-invariants-single term term* invariantds new-invs-list generalized-target target uncond-target keep S)))
			      acc terms*))
	      (list invariantds new-invs-list) terms))

(defun find-leq-invariants (req-hyps term-cache* invariantds compares generalized-target target uncond-target collect-new-invariants keep S)
  (let* ((res (list.foldr #'(lambda (d acc)
			      (let* ((lhs-size (car d))
				     (rhs-size (cadr d))
				     (terms (map.find-default (map.find-default term-cache* lhs-size map.empty) 'c-uintp ()))
				     (terms* (map.find-default (map.find-default term-cache* rhs-size map.empty) 'c-uintp ()))
				     (terms** (map.find-default (map.find-default term-cache* lhs-size map.empty) 'c-intp ()))
				     (terms*** (map.find-default (map.find-default term-cache* rhs-size map.empty) 'c-intp ()))
				     
				     (invariantds (car acc))
				     (new-invs-list (cadr acc))
				     (invariantds (map.add-overwrite invariantds (<=-key.make lhs-size rhs-size) ())) ;; TODO!
				     (invariantds (map.add-overwrite invariantds (<-key.make lhs-size rhs-size) ())) ;; TODO!

				     (acc* (if (or (endp terms) (endp terms*))
						(list invariantds new-invs-list)
					      (find-leq-invariants-pair terms terms* generalized-target target uncond-target invariantds new-invs-list keep S)))
				     (invariantds* (car acc*))
				     (new-invs-list* (cadr acc*))

				     (acc** (if (or (endp terms**) (endp terms***))
						 (list invariantds* new-invs-list*)
					       (find-leq-invariants-pair terms** terms*** generalized-target target uncond-target invariantds* new-invs-list* keep S)))
				     (invariantds** (car acc**))
				     (new-invs-list** (cadr acc**)))
				(list invariantds** new-invs-list**)))
			  (list invariantds ()) compares))
	 (invariantds* (car res))
	 (new-invs-list* (cadr res)))
    (list new-invs-list* invariantds*)))

(define-condition bad-invariantd (error)
  ((text :initarg :text :reader text)))

(defun bad-or-invariantd (invariantd invariantd*)
  (and *do-invariant-pruning*
       (let* ((res (or (and (equal (invariantd.t invariantd) '<)
			    (equal (invariantd.t invariantd*) 'equal)
			    (term.equal (<-invariantd.lhs invariantd) (equal-invariantd.lhs invariantd*))
			    (term.equal (<-invariantd.rhs invariantd) (equal-invariantd.rhs invariantd*)))
		       (and (equal (invariantd.t invariantd) '<)
			    (equal (invariantd.t invariantd*) 'equal)
			    (term.equal (<-invariantd.lhs invariantd) (equal-invariantd.rhs invariantd*))
			    (term.equal (<-invariantd.rhs invariantd) (equal-invariantd.lhs invariantd*)))
		       (and (equal (invariantd.t invariantd) 'equal)
			    (equal (invariantd.t invariantd*) '<)
			    (term.equal (equal-invariantd.lhs invariantd) (<-invariantd.lhs invariantd*))
			    (term.equal (equal-invariantd.rhs invariantd) (<-invariantd.rhs invariantd*)))
		       (and (equal (invariantd.t invariantd) 'equal)
			    (equal (invariantd.t invariantd*) '<)
			    (term.equal (equal-invariantd.lhs invariantd) (<-invariantd.rhs invariantd*))
			    (term.equal (equal-invariantd.rhs invariantd) (<-invariantd.lhs invariantd*)))
		       (and (equal (invariantd.t invariantd) '<=)
			    (equal (invariantd.t invariantd*) 'equal)
			    (term.equal (<=-invariantd.lhs invariantd) (equal-invariantd.lhs invariantd*))
			    (term.equal (<=-invariantd.rhs invariantd) (equal-invariantd.rhs invariantd*)))
		       (and (equal (invariantd.t invariantd) '<=)
			    (equal (invariantd.t invariantd*) 'equal)
			    (term.equal (<=-invariantd.lhs invariantd) (equal-invariantd.rhs invariantd*))
			    (term.equal (<=-invariantd.rhs invariantd) (equal-invariantd.lhs invariantd*)))
		       (and (equal (invariantd.t invariantd) 'equal)
			    (equal (invariantd.t invariantd*) '<=)
			    (term.equal (equal-invariantd.lhs invariantd) (<=-invariantd.lhs invariantd*))
			    (term.equal (equal-invariantd.rhs invariantd) (<=-invariantd.rhs invariantd*)))
		       (and (equal (invariantd.t invariantd) 'equal)
			    (equal (invariantd.t invariantd*) '<=)
			    (term.equal (equal-invariantd.lhs invariantd) (<=-invariantd.rhs invariantd*))
			    (term.equal (equal-invariantd.rhs invariantd) (<=-invariantd.lhs invariantd*))))))
					;(if res (print (list (invariantd.destruct invariantd) (invariantd.destruct invariantd*) res)) '_)
	 res)))

(defun find-or-invariant-single (invariantd invariantd* generalized-target target uncond-target acc collect-new-invariants)
  (if (or (not collect-new-invariants) (bad-or-invariantd invariantd invariantd*)) acc
    (let* ((evals (invariantd.get-data invariantd target))
	   (evals* (invariantd.get-data invariantd* target))
	   (g-evals (invariantd.get-data invariantd generalized-target))
	   (g-evals* (invariantd.get-data invariantd* generalized-target)))
      (if (or ;; if it seems to hold unconditionally
	   (list.foldr2 #'(lambda (eval eval* acc)
			    (and acc (option.exists eval) (option.exists eval*) (or (option.get eval) (option.get eval*))))
			t (invariantd.get-data invariantd uncond-target) (invariantd.get-data invariantd* uncond-target))
	   ;; if one seems to imply the other
	   (list.foldr2 #'(lambda (eval eval* acc)
			    (and acc (option.exists eval) (option.exists eval*) (or (not (option.get eval)) (option.get eval*))))
			t (invariantd.get-data invariantd uncond-target) (invariantd.get-data invariantd* uncond-target))
	   (list.foldr2 #'(lambda (eval eval* acc)
			    (and acc (option.exists eval) (option.exists eval*) (or (option.get eval) (not (option.get eval*)))))
			t (invariantd.get-data invariantd uncond-target) (invariantd.get-data invariantd* uncond-target)))
	  acc
	(let* ((test (or (list.foldr2 #'(lambda (eval eval* acc)
					  (and acc (option.exists eval) (option.exists eval*) (or (option.get eval) (option.get eval*))))
				      t evals evals*)
			 (and (not (endp g-evals))
			      (not (endp g-evals*))
			      (list.foldr2 #'(lambda (eval eval* acc)
					       (and acc (option.exists eval) (option.exists eval*) (or (option.get eval) (option.get eval*))))
					   t g-evals g-evals*)))))
	  (if test
	      (cons (or-invariantd.make invariantd invariantd*) acc)
	    acc))))))

(defun find-or-invariants-same (req-hyps invariantd-list generalized-target target uncond-target acc collect-new-invariants)
  (if (endp invariantd-list)
      acc
    (let* ((invariantd (car invariantd-list))
	   (acc* (list.foldr #'(lambda (invariantd* acc) (find-or-invariant-single invariantd invariantd* generalized-target target uncond-target acc collect-new-invariants)) acc (cdr invariantd-list))))
      (find-or-invariants-same req-hyps (cdr invariantd-list) generalized-target target uncond-target acc* collect-new-invariants))))

(defun find-or-invariants-pair (req-hyps invariantd-list invariantd-list* generalized-target target uncond-target acc collect-new-invariants)
  (list.foldr #'(lambda (invariantd acc)
		  (list.foldr #'(lambda (invariantd* acc)
				  (find-or-invariant-single invariantd invariantd* generalized-target target uncond-target acc collect-new-invariants))
			      acc invariantd-list*))
	      acc invariantd-list))

(defun find-or-invariants (req-hyps invariantds generalized-target target uncond-target key-pairs collect-new-invariants)
  (list.foldr #'(lambda (key-pair acc)
		  (let* ((key (car key-pair))
			 (key* (cadr key-pair)))
		    (if (equal key key*)
			(progn #|(print (list 'finding 'or 'invariantds 'single key
					    (list.map #'invariantd.destruct (map.find-default invariantds key ()))))|#
			  (find-or-invariants-same req-hyps (map.find-default invariantds key ()) generalized-target target uncond-target acc collect-new-invariants))
		      (progn #|(print (list 'finding 'or 'invariantds 'pair key key*
					  (list.map #'invariantd.destruct (map.find-default invariantds key ()))
					  (list.map #'invariantd.destruct (map.find-default invariantds key* ()))))|#
			(find-or-invariants-pair req-hyps (map.find-default invariantds key ()) (map.find-default invariantds key* ()) generalized-target target uncond-target acc collect-new-invariants)))))
	      () key-pairs))

		  
(defun find-not-invariants (req-hyps invariantds generalized-target target uncond-target keys collect-new-invariants keep)
  (list.foldr #'(lambda (key acc)
		(let* ((invariantd-list (map.find-default invariantds key ()))
		       (not-invariants (car acc))
		       (invariantds* (cadr acc))
		       (new-key (list 'not key))
		       (res (list.foldr #'(lambda (invariantd acc)
					    (let* ((invariants (car acc))
						   (possible (cadr acc))
						   (new (not-invariantd.make invariantd))
						   (possible* (if keep (cons new possible) possible)))
					      (populate-invariantd-data new uncond-target)
					      (if (list.forall #'(lambda (x) (and (option.exists x) (option.get x)))
							       (invariantd.get-data new uncond-target))
						  acc
						(if collect-new-invariants
						    (progn (populate-invariantd-data new target)
							   (let* ((test (list.forall #'(lambda (x) (and (option.exists x) (option.get x)))
										     (invariantd.get-data new target)))
								  (invariants* (if test (cons new invariants) invariants)))
							     (list invariants* possible*)))
						  (list invariants possible*)))))
					(list not-invariants ()) invariantd-list))
		       (not-invariants* (car res))
		       (possible (cadr res))
		       (invariantds** (map.add-exn invariantds* new-key possible)))
		  (list not-invariants* invariantds**)))
	    (list () invariantds) keys))



